﻿using System.Web.Mvc;
using Mvc3RavenDbEmbed.Models;
using Raven.Client;

namespace Mvc3RavenDbEmbed.Controllers
{
    public class BaseDocumentStoreController : Controller
    {
        public IDocumentSession DocumentSession { get; set; }

        protected override void OnActionExecuting(ActionExecutingContext filterContext)
        {
            if (filterContext.IsChildAction)
                return;
            this.DocumentSession = DataDocumentStore.Instance.OpenSession();
            base.OnActionExecuting(filterContext);
        }

        protected override void OnActionExecuted(ActionExecutedContext filterContext)
        {
			if (filterContext.IsChildAction)
				return;
            if (this.DocumentSession != null && filterContext.Exception == null)
                this.DocumentSession.SaveChanges();
            this.DocumentSession.Dispose();
            base.OnActionExecuted(filterContext);
        }
    }
}